<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Game extends MY_Controller {

	public function index()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			redirect('game/listing', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}

	public function listing()
	{
		save_current_url(base_url() . 'game/listing/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			if($_POST) {
				$this->session->set_userdata(
					array(
						'member_search_username' => trim($this->input->post('search_username', TRUE)), 
						'member_search_game_username' => trim($this->input->post('member_search_game_username', TRUE)),
						'member_search_deposit_date' => trim($this->input->post('search_deposit_date', TRUE)), 
						'member_search_start_date' => trim($this->input->post('search_start_date', TRUE)), 
						'member_search_end_date' => trim($this->input->post('search_end_date', TRUE)), 
						'member_search_deposit_status' => ($this->input->post('search_deposit_status', TRUE) != '') ? implode(',', $this->input->post('search_deposit_status', TRUE)) : ''
						)
				);
				
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_game') . ' - ' .$this->lang->line('hf_game_deposit_history');
			
				$this->load->view('game_deposit_history', $_POST);
			}
			else {
				$this->session->unset_userdata(array('member_search_username' => '', 'member_search_game_username' => '', 'member_search_deposit_date' => '', 'member_search_start_date' => '', 'member_search_end_date' => '', 'member_search_deposit_status' => ''));
				
				$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_game') . ' - ' .$this->lang->line('hf_game_deposit_history');
			
				$this->load->view('game_deposit_history', $data);
			}
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function getList()
    {
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			$aColumns = array(
								$this->db->dbprefix('member_board_game_deposits') . '.member_transaction_id',
								$this->db->dbprefix('member_board_game_deposits') . '.transaction_date',
								$this->db->dbprefix('member_board_game_deposits') . '.credit_amount',
								$this->db->dbprefix('member_board_game_deposits') . '.to_member_username',
								$this->db->dbprefix('member_board_game_deposits') . '.from_member_username',
								$this->db->dbprefix('member_board_game_deposits') . '.status'
							);
			
			// DB table to use
			$sTable = 'sw_member_board_game_deposits';
			//
			
			if($this->session->userdata('member_search_deposit_date') != '') {
				if($this->session->userdata('member_search_deposit_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_board_game_deposits') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_board_game_deposits') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".from_member_username = '" . $this->session->userdata('member_search_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_game_username') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".to_member_username = '" . $this->session->userdata('member_search_game_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_deposit_status') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".status IN(" .  $this->session->userdata('member_search_deposit_status') . ")";
				$this->db->where($where);
			}
			
			$this->db->where($this->db->dbprefix('member_board_game_deposits') . '.transaction_type', 1);
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				if($aRow['status'] == 0) {
					$row[] = '<input type="checkbox" name="chkbox[]" value="' . $aRow['member_transaction_id'] . '" onchange="checkOrUncheck(this);" />';
				}
				else {
					$row[] = '';
				}
				
				$row[] = date('Y-m-d H:i:s', $aRow['transaction_date']);
				$row[] = number_format($aRow['credit_amount'], 2, '.', '');
				$row[] = $aRow['to_member_username'];
				$row[] = $aRow['from_member_username'];
				
				switch($aRow['status']) {
					case 0: $row[] = $this->lang->line('topup_pending'); break;
					case 1: $row[] = $this->lang->line('topup_confirmed'); break;
					case 2: $row[] = $this->lang->line('topup_cancelled'); break;
					default: $row[] = $this->lang->line('topup_pending'); break;
				}
				
				if($aRow['status'] == 0) {
					$row[] = '<select id="update_status" name="update_status" class="small m-wrap" onchange="update_deposit_status(' . $aRow['member_transaction_id'] . ', this.value)">
								<option value="0">' . $this->lang->line('withdrawal_pending_withdrawal') . '</option>
								<option value="1">' . $this->lang->line('withdrawal_approve_withdrawal') . '</option>
								<option value="2">' . $this->lang->line('withdrawal_cancel_withdrawal') . '</option>
							</select>';
				}
				else {
					$row[] = '';
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
	
	public function export()
	{
		set_time_limit(0);
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			require_once APPPATH."/third_party/php-excel.class.php";
			
			$data[] = array (
								$this->lang->line('game_request_date'),
								$this->lang->line('game_amount'),
								$this->lang->line('game_game_username'),
								$this->lang->line('game_from_member'),
								$this->lang->line('game_status')
							);
			
			//Get Data
			$aColumns = array(
								$this->db->dbprefix('member_board_game_deposits') . '.transaction_date',
								$this->db->dbprefix('member_board_game_deposits') . '.credit_amount',
								$this->db->dbprefix('member_board_game_deposits') . '.to_member_username',
								$this->db->dbprefix('member_board_game_deposits') . '.from_member_username',
								$this->db->dbprefix('member_board_game_deposits') . '.status'
							);
			
			// DB table to use
			$sTable = 'sw_member_board_game_deposits';
			//
			
			if($this->session->userdata('member_search_deposit_date') != '') {
				if($this->session->userdata('member_search_deposit_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_board_game_deposits') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_board_game_deposits') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_username') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".from_member_username = '" . $this->session->userdata('member_search_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_game_username') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".to_member_username = '" . $this->session->userdata('member_search_game_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_deposit_status') != '') {
				$where = $this->db->dbprefix('member_board_game_deposits') . ".status IN(" .  $this->session->userdata('member_search_deposit_status') . ")";
				$this->db->where($where);
			}
			
			$this->db->where($this->db->dbprefix('member_board_game_deposits') . '.transaction_type', 1);
			
			$this->db->order_by($this->db->dbprefix('member_board_game_deposits') . '.transaction_date', 'asc');
			
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
			
			foreach($rResult->result_array() as $aRow)
			{
				$status = '';
				switch($aRow['status']) {
					case 0: $status = $this->lang->line('topup_pending'); break;
					case 1: $status = $this->lang->line('topup_confirmed'); break;
					case 2: $status = $this->lang->line('topup_cancelled'); break;
					default: $status = $this->lang->line('topup_pending'); break;
				}
				
				$data[] = array (
									date('Y-m-d H:i:s', $aRow['transaction_date']),
									number_format($aRow['credit_amount'], 2, '.', ''),
									$aRow['to_member_username'],
									$aRow['from_member_username'],
									$status
								);
			}
					
			$xls = new Excel_XML('UTF-8', false, 'Member Game Deposit List');
			$xls->addArray($data);
			$xls->generateXML('member_game_deposit_list');
		}
	}
	
	public function update_deposit($transaction_id = NULL, $status = NULL)
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$this->load->model('user_model');
			
			$rs = $this->user_model->update_game_deposit_status($transaction_id, $status);
				
			redirect('game/listing/', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function listing_update()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$this->load->model('user_model');
			
			#Recursive deletion
			if(isset($_POST['chkbox'])) {
				for($i=0;$i<sizeof($_POST['chkbox']);$i++) {
					if($_POST['chkbox'][$i] != 'on') {
						$this->user_model->update_game_deposit_status(trim($_POST['chkbox'][$i]), trim($_POST['update_status']));
					}
				}
			}
			
			redirect('game/listing/', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
}

/* End of file game.php */
/* Location: ./application/controllers/game.php */